//*****************************************************************************************************
//  1. t@C
//		General.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		ėp֐NX̎
//----------------------------------------------------------------------------------------------------
//  3. l
//----------------------------------------------------------------------------------------------------
//  4. 
//		2007.08.09 S.Aizawa VK쐬
//*****************************************************************************************************

#include "StdAfx.h"
#include "General.h"
#include "DigitalFilter.h"
#include "GlobalData.h"
#include <math.h>
#include <direct.h>
#include <io.h>

//*****************************************************************************************************
//  1. ֐
//		CGeneral::FormatTime
//----------------------------------------------------------------------------------------------------
//  2. @\
//		~bPʂ̐l"HH:MM:SS.999"`ɕϊ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		double		fSecond			[I] b
//		int			nDecimal		[I] ~bȉ̌
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		CString		ϊ
//*****************************************************************************************************
CString CGeneral::FormatTime(double fSecond, int nDecimal)
{
	CString sText;

	int nDigit = 1;
	for (int i = 0; i < nDecimal; i++)
		nDigit *= 10;

	int nMiliSecond = (int)(fSecond * nDigit + 0.5);
	int nHour = nMiliSecond / (60 * 60 * nDigit);
	nMiliSecond -= nHour * (60 * 60 * nDigit);

	int nMinute = nMiliSecond / (60 * nDigit);
	nMiliSecond -= nMinute * (60 * nDigit);

	int nSecond = nMiliSecond / nDigit;
	nMiliSecond -= nSecond * nDigit;

	if (nHour >= 24)
		nHour = nHour % 24;

	if (nDecimal) {
		CString sFormat;
		sFormat.Format("%%02d:%%02d:%%02d.%%0%dd", nDecimal);
		sText.Format(sFormat, nHour, nMinute, nSecond, nMiliSecond);
	} else
		sText.Format("%02d:%02d:%02d", nHour, nMinute, nSecond);

	return sText;
}

//*****************************************************************************************************
//  1. ֐
//		CGeneral::Alert
//----------------------------------------------------------------------------------------------------
//  2. @\
//		A[gbZ[W\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR		pMessage			[I] \郁bZ[W
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGeneral::Alert(LPCTSTR pMessage, ...)
{
	va_list args;
	va_start(args, pMessage);

	CString sMessage;
	sMessage.FormatV(pMessage, args);

	CWnd::GetActiveWindow()->MessageBox(sMessage, NULL, MB_OK | MB_ICONEXCLAMATION | MB_SYSTEMMODAL);
}

//*****************************************************************************************************
//  1. ֐
//		CGeneral::SetSampleRateList
//----------------------------------------------------------------------------------------------------
//  2. @\
//		TvOg̃R{{bNXݒ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CComboBox		&cComboBox			[O] R{{bNX
//		double			fSampleRate			[I] TvOg
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGeneral::SetSampleRateList(CComboBox &cComboBox, double fSampleRate)
{
	CString sText;

	// TvOg̃R{{bNXݒ
	int nDiv = 1;
	// Ԉ\́C1/1C1/2C1/4ŊԈ
	for (int i = 0; i < 3; i++) {
		sText.Format("1/%d", nDiv);
		cComboBox.SetItemData(cComboBox.AddString(sText), nDiv);

		nDiv *= 2;
	}

	cComboBox.SetCurSel(0);
}		

//*****************************************************************************************************
//  1. ֐
//		CGeneral::DelDir
//----------------------------------------------------------------------------------------------------
//  2. @\
//		wtH_ɑ݂t@CSĂ폜
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCSTR		path			[I] wtH_
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		bool	trueF@falseFs
//*****************************************************************************************************
bool CGeneral::DelDir(LPCSTR path)
{
	char wpath[MAX_PATH];
	struct _finddata_t c_file;
    intptr_t hFile;
	CString	str;

	memset(wpath, 0, sizeof(wpath));
	strcpy_s(wpath, path);
	strcat_s(wpath, "\\*.*");

    /* Jg fBNg̍ŏ̃tH_T܂B*/
	if( (hFile = _findfirst(wpath, &c_file )) != -1L ) {
		// tH_H
		if (c_file.attrib & _A_SUBDIR) {
			if (c_file.name[0] != '.') {
				str.Format("%s\\%s", path, c_file.name);
				if (! DelDir((LPCSTR)str)) {
					_findclose( hFile );
					return false;
				}
			}
		} else {
			str.Format("%s\\%s", path, c_file.name);
			if (remove((LPCSTR)str) == -1) {
				_findclose( hFile );
				return false;
			}
		}
		/* c̃tH_T܂B */
		while( _findnext( hFile, &c_file ) == 0 ) {
			// tH_H
			if (c_file.attrib & _A_SUBDIR) {
				if (c_file.name[0] != '.') {
					str.Format("%s\\%s", path, c_file.name);
					if (! DelDir((LPCSTR)str)) {
						_findclose( hFile );
						return false;
					}
				}
			} else {
				str.Format("%s\\%s", path, c_file.name);
				if (remove((LPCSTR)str) == -1) {
					_findclose( hFile );
					return false;
				}
			}
		}
		_findclose( hFile );
		_rmdir(path);
	}
	return true;
}

//*****************************************************************************************************
//  1. ֐
//		CGeneral::SetFilterBandList
//----------------------------------------------------------------------------------------------------
//  2. @\
//		R{{bNXɃtB^̎ނZbg
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CComboBox		&cComboBox			[O] R{{bNX
//		int				nCurSel				[I] Iʒu
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGeneral::SetFilterBandList(CComboBox &cComboBox, int nCurSel)
{
	cComboBox.SetItemData(cComboBox.AddString(""), -1);
	cComboBox.SetItemData(cComboBox.AddString("LPF"), EDF_LPF);
	cComboBox.SetItemData(cComboBox.AddString("HPF"), EDF_HPF);
	cComboBox.SetItemData(cComboBox.AddString("BPF"), EDF_BPF);
	cComboBox.SetItemData(cComboBox.AddString("BSF"), EDF_BSF);

	cComboBox.SetCurSel(nCurSel);
}

//*****************************************************************************************************
//  1. ֐
//		CGeneral::SetFilterOrderList
//----------------------------------------------------------------------------------------------------
//  2. @\
//		R{{bNXɃtB^̎Zbg
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CComboBox		&cComboBox			[O] R{{bNX
//		int				nCurSel				[I] Iʒu
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGeneral::SetFilterOrderList(CComboBox &cComboBox, int nCurSel)
{
	CString sText;

	for (int nOrder = 1; nOrder <= 10; nOrder++) {
		sText.Format("%d", nOrder);
		cComboBox.SetItemData(cComboBox.AddString(sText), nOrder);
	}

	cComboBox.SetCurSel(nCurSel);
}

//*****************************************************************************************************
//  1. ֐
//		CGeneral::SetFilterTypeList
//----------------------------------------------------------------------------------------------------
//  2. @\
//		R{{bNXɃtB^̓Zbg
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CComboBox		&cComboBox			[O] R{{bNX
//		int				nCurSel				[I] Iʒu
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGeneral::SetFilterTypeList(CComboBox &cComboBox, int nCurSel)
{
	cComboBox.SetItemData(cComboBox.AddString("Butterworth"), EDF_Butterworth);
	cComboBox.SetItemData(cComboBox.AddString("Chebyshev"), EDF_Chebyshev);
	cComboBox.SetItemData(cComboBox.AddString("Bessel"), EDF_Bessel);

	cComboBox.SetCurSel(nCurSel);
}

//*****************************************************************************************************
//  1. ֐
//		CGeneral::FormatExp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		w肵̎w`ɕϊ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		double		fData			[I] ϊf[^
//		int			nDigit			[I] 
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		CString		ϊ
//*****************************************************************************************************
CString CGeneral::FormatExp(double fData, int nDigit)
{
	CString sFormat, sText;

	sFormat.Format("%%.%de", nDigit);
	sText.Format(sFormat, fData);
	int nPos = sText.Find('e');
	if (nPos >= 0) {
		CString sExp;
		sExp.Format("%d", atoi(sText.Mid(nPos + 1)));
		return sText.Left(nPos + 1) + sExp;
	} else
		return sText;
}

//*****************************************************************************************************
//  1. ֐
//		CGeneral::SetToolTip
//----------------------------------------------------------------------------------------------------
//  2. @\
//		c[`bvݒ肷
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CToolTipCtrl	&tooltip			[I] c[`bvRg[
//		SToolTipData	*pToolTipData		[I] c[`bv\f[^
//		CWnd			*pWnd				[I] EBhE|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGeneral::SetToolTip(CToolTipCtrl &tooltip, const SToolTipData *pToolTipData, CWnd *pWnd)
{
	tooltip.Create(pWnd);

	while (pToolTipData->nID) {
		CWnd *pWndControl = pWnd->GetDlgItem(pToolTipData->nID);
		if (pWndControl != NULL)
			tooltip.AddTool(pWndControl, pToolTipData->pMsg);
		pToolTipData++;
	}

	tooltip.SetMaxTipWidth(400);
	tooltip.EnableToolTips();
}

//*****************************************************************************************************
//  1. ֐
//		CGeneral::StrSplit
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Zp[^ŋ؂ꂽ𕪉ĔzɃZbg
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR			pText			[I] 
//		LPCTSTR			pSeparator		[I] Zp[^
//		CStringArray	&saText			[O] z
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGeneral::StrSplit(LPCTSTR pText, LPCTSTR pSeparator, CStringArray &saText)
{
	saText.RemoveAll();

	int nPos= 0;
	CString sText(pText);
	CString sToken = sText.Tokenize(pSeparator, nPos);

	while (sToken != "") {
		saText.Add(sToken);
		sToken = sText.Tokenize(pSeparator, nPos);
	}
}

//*****************************************************************************************************
//  1. ֐
//		CGeneral::StrJoin
//----------------------------------------------------------------------------------------------------
//  2. @\
//		zZp[^ŘA
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CStringArray	&saText			[I] z
//		LPCTSTR			pSeparator		[I] Zp[^
//		CString			&sText			[O] A
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGeneral::StrJoin(const CStringArray &saText, LPCTSTR pSeparator, CString &sText)
{
	sText.Empty();

	for (int i = 0; i < saText.GetSize(); i++) {
		if (i != 0)
			sText += pSeparator;

		sText += saText[i];
	}
}

//*****************************************************************************************************
//  1. ֐
//		CGeneral::CheckFileName
//----------------------------------------------------------------------------------------------------
//  2. @\
//		t@CifBNgjƂėL`FbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CString			sText			[I] `FbN镶
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		TRUE:LCFALSE:
//*****************************************************************************************************
BOOL CGeneral::CheckFileName(CString sText)
{
	return sText.SpanExcluding("\\/:*?\"<>|") == sText;
}

//*****************************************************************************************************
//  1. ֐
//		CGeneral::SetComboCategory
//----------------------------------------------------------------------------------------------------
//  2. @\
//		R{{bNXɃJeS̑Iݒ肷
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CComboBox		&oComboBox			[I] JeS̃R{{bNX
//		CString			sChoiceText			[O] ݐݒ肳Ă镶
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGeneral::SetComboCategory(CComboBox &oComboBox, CString sChoiceText)
{
	oComboBox.ResetContent();
	for (int i = 0; i < gChoiceCategory.GetSize(); i++) {
		if (CheckFileName(gChoiceCategory[i]))
			oComboBox.AddString(gChoiceCategory[i]);
	}

	oComboBox.SetWindowText(sChoiceText);
}

//*****************************************************************************************************
//  1. ֐
//		CGeneral::SetComboMeasurementKind
//----------------------------------------------------------------------------------------------------
//  2. @\
//		R{{bNXɌvނ̑Iݒ肷
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CComboBox		&oComboBox			[I] JeS̃R{{bNX
//		CString			sChoiceText			[O] ݐݒ肳Ă镶
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGeneral::SetComboMeasurementKind(CComboBox &oComboBox, CString sChoiceText)
{
	oComboBox.ResetContent();
	for (int i = 0; i < gChoiceMeasurementKind.GetSize(); i++) {
		if (CheckFileName(gChoiceMeasurementKind[i]))
			oComboBox.AddString(gChoiceMeasurementKind[i]);
	}

	oComboBox.SetWindowText(sChoiceText);
}

//*****************************************************************************************************
//  1. ֐
//		CGeneral::CheckFileName
//----------------------------------------------------------------------------------------------------
//  2. @\
//		t@CifBNgjƂėL`FbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CString			sItem			[I] ږ
//		CString			sText			[I] `FbN镶
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		TRUE:LCFALSE:
//*****************************************************************************************************
BOOL CGeneral::CheckFileName(CString sItem, CString sText)
{
	if (!CheckFileName(sText)) {
		Alert("%sɁu\\/:*?\"<>|v܂ނƂ͂ł܂B", sItem);
		return FALSE;
	}

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CGeneral::CreateDirectoryAll
//----------------------------------------------------------------------------------------------------
//  2. @\
//		w肳ꂽfBNg܂őSĂ̊Kw̃fBNg쐬
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR			pDirPath		[I] 쐬fBNg
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		TRUE:CFALSE:G[
//*****************************************************************************************************
BOOL CGeneral::CreateDirectoryAll(LPCTSTR pDirPath)
{
	DWORD err;
	char *p;
	char buf[_MAX_PATH];

	if (!::CreateDirectory(pDirPath, NULL)) {
		err = GetLastError();
		if (err == ERROR_ALREADY_EXISTS)
			return TRUE;
		else if (err == ERROR_PATH_NOT_FOUND) {
			strcpy_s(buf, pDirPath);
			if ((p = strrchr(buf, '\\')) != NULL) {
				*p = '\0';
				if (CreateDirectoryAll(buf))
					return CreateDirectory(pDirPath, NULL);
				else
					return FALSE;
			} else
				return FALSE;
		} else
			return FALSE;
	}

	return TRUE;
}
